# RunAbout

## Introduction

**RunAbout** is a streamlined AutoHotkey script that transforms how users interact with their desktop. By providing a quick-access interface for running commands and performing web searches, it removes the need for manual navigation through browsers or file explorers.
Enhanced with customizable aliases, history management, and administrator support, RunAbout offers a fast, efficient, and intuitive alternative to Windows' native Run feature.

## Overview

**RunAbout** is an **AutoHotkey**-based script that allows you to:

* **Run applications or files**,
* **Search on Google**,
* **Manage custom aliases** for your favorite commands.

All through a simple, lightweight interface designed for quick access.

## Features

### 1. Run

When you select the **Run** option:

* A window will pop up similar to the classic Windows Run (Win+R) window but with enhanced capabilities:

  * Executes commands from saved aliases.
  * Saves your command history into a file (`commandHistory.ini`), editable if needed.
  * Avoids duplicates: each command is stored only once.
  * Allows an unlimited number of saved commands, unlike the built-in Windows Run which is limited.
  * Provides an easy GUI, including a button to **Run as Administrator** if required.

### 2. Web Search

Use **Web Search** when you want to quickly search Google without opening your browser manually.

* **Notes about Web Search**:

  * It will open your default browser.
  * It uses the last active profile in your browser.

### 3. Alias Manager

The **Alias Manager** lets you:

* Add new aliases: shortcuts to open files, folders, or links.
* Remove existing aliases easily.

**Example usage**:
Instead of typing a long path every time, create an alias linked to the path. Later, you just type the alias in the run window, and it will open the correct file, folder, or link.

**Notes for Aliases**:

* Make sure the path is **absolute**, not relative.
  Example:
  Instead of typing `documents`, use `C:\Users\YourUsername\Documents`.
* If you're adding a website link, it **must** start with `https://` or `http://`.
  Typing only `www.youtube.com` will not work, but `https://www.youtube.com` will.

### 4. Commands in This Application

* **Win+R** → Open RunAbout's GUI.
* **Win+Ctrl+Shift+R** → Exit the application and restore your system’s default Run behavior.

## Requirements

* **AutoHotkey** (version 1.1 or newer)
  Download it here: [https://www.autohotkey.com/](https://www.autohotkey.com/)

## Installation

1. Install AutoHotkey.
2. Download `RunAbout.ahk`.
3. Double-click the `.ahk` file to launch, or compile it if you want an executable version.

## File Structure

* `commandHistory.ini`: Stores your recent command history.
* `alias.ini`: Stores all your custom aliases.

Both files are auto-created if missing.

## Frequently Asked Questions

**Q: Will this application consume a lot of RAM?**
A: No. RunAbout is designed to be lightweight and will not significantly impact system memory usage.

**Q: If I don’t use this app, will it affect my Windows Run history?**
A: No. RunAbout operates independently. Your Windows Run and its history are untouched. This app manages its own history separately.

## Conclusion

Thank you for reading and trying out this simple application!
If you have any questions, suggestions, or complaints, feel free to contact me.

## License

This project is licensed under the [MIT License](MIT-LICENSE.txt).

---

> Made with  and by TechLabs.
